Summary: cvsd, a chroot/suid wrapper for running a cvs pserver.
Name: cvsd
Version: 0.6
Release: 2
Copyright: GPL
Group: Development/Version Control
Source0: http://cblack.mokey.com/cvsd/cvsd-0.6.tar.gz
Patch0: cvsd-passwd.patch
Patch1: cvsd-chdir.patch
URL: http://cblack.mokey.com/cvsd/
Packager: Progfou <Jean-Christophe.ANDRE@aupelf.refer.org>
Vendor: Chris Black <cblack@mokey.com>
Requires: cvs
Buildroot: /var/tmp/%{name}-root

%description
cvsd is a chroot/suid wrapper for running a cvs pserver more securely.
cvs is a version control system for managing projects.

%prep
%setup
%patch0 -p1
%patch1 -p1

%build
make all

%install
#rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/usr/sbin
cp -a cvsd ${RPM_BUILD_ROOT}/usr/sbin
mkdir -p ${RPM_BUILD_ROOT}/etc
cp -a cvsd.conf ${RPM_BUILD_ROOT}/etc
mkdir -p ${RPM_BUILD_ROOT}/home/cvsowner/cvsd-root/etc
cp -a cvsd-passwd ${RPM_BUILD_ROOT}/home/cvsowner/cvsd-root/etc/passwd
mkdir -p ${RPM_BUILD_ROOT}/home/cvsowner/cvsd-root/bin
mkdir -p ${RPM_BUILD_ROOT}/home/cvsowner/cvsd-root/lib
mkdir -p ${RPM_BUILD_ROOT}/home/cvsowner/cvsd-root/dev
cp -a /dev/null ${RPM_BUILD_ROOT}/home/cvsowner/cvsd-root/dev
mkdir -p ${RPM_BUILD_ROOT}/home/cvsowner/cvsd-root/tmp
mkdir -p ${RPM_BUILD_ROOT}/home/cvsowner/cvsd-root/cvsroot

export PREFIX=${RPM_BUILD_ROOT}
#make -e install

%clean
rm -rf ${RPM_BUILD_ROOT}

%pre
#SRCDIR=$PWD
if ! grep -q cvsadmin /etc/group
then
  echo "Creating group cvsadmin..."
  groupadd -g 2401 cvsadmin
fi
if ! grep -q cvsowner /etc/passwd
then
  echo "Creating user cvsowner..."
  useradd -u 2401 -g cvsadmin -d /home/cvsowner -s /bin/bash -c "CVS UID" -m cvsowner
  chown -R cvsowner.cvsadmin /home/cvsowner
fi
if ! grep -q cvspserver /etc/services ; then
  echo "no existing cvspserver line in /etc/services, adding..."
  echo -e "cvspserver\t2401/tcp\t\t# CVS pserver auth" >> /etc/services
fi
if ! grep -q cvspserver /etc/inetd.conf ; then
  echo "no existing cvspserver line in /etc/inetd.conf, adding..."
  echo -e "cvspserver\tstream\ttcp\tnowait\troot\t/usr/sbin/cvsd\tcvsd" >> /etc/inetd.conf
  /etc/rc.d/init.d/inet reload
fi

%post
libnssfile=/lib/$(strings /lib/libc.so.6 | grep libnss_file)
if [ ! -f /home/cvsowner/cvsd-root/$libnssfile ] ; then
  echo "Setting up /home/cvsowner/cvsd-root..."
  install -m0755 $libnssfile $(ldd /usr/bin/cvs | awk '{print $3}') /home/cvsowner/cvsd-root/lib/
  install -m0755 /usr/bin/cvs /home/cvsowner/cvsd-root/bin/
fi
if [ ! -f /home/cvsowner/cvsd-root/CVSROOT ]
then
  su -c 'cvs -d ~/cvsd-root/cvsroot init' - cvsowner
  chown -R cvsowner.cvsadmin /home/cvsowner/cvsd-root/cvsroot
fi
echo "Now edit/modify/whatever the /home/cvsowner/cvsd-root/etc/passwd file."
echo "Default user/passwds are cvs/cvs (for ro anon), user/pass. Change these!"

%preun
libnssfile=/lib/$(strings /lib/libc.so.6 | grep libnss_file)
rm -f /home/cvsowner/cvsd-root/bin/cvs
for f in $libnssfile $(ldd /usr/bin/cvs | awk '{print $3}')
do
  rm -f /home/cvsowner/cvsd-root$f
done

%postun
/usr/sbin/userdel cvsowner
/usr/sbin/groupdel cvsadmin

%files
%attr(0644,root,root) %doc README
%attr(0755,root,root) /usr/sbin/cvsd
%attr(0644,root,root) %config(noreplace) /etc/cvsd.conf
%attr(0755,root,root) %dir /home/cvsowner/cvsd-root
%attr(0755,root,root) %dir /home/cvsowner/cvsd-root/etc
%attr(0644,cvsowner,cvsadmin) %config(noreplace) /home/cvsowner/cvsd-root/etc/passwd
%attr(0755,root,root) /home/cvsowner/cvsd-root/bin
%attr(0755,root,root) /home/cvsowner/cvsd-root/lib
%attr(0755,root,root) /home/cvsowner/cvsd-root/dev
%attr(1777,root,root) /home/cvsowner/cvsd-root/tmp
%attr(0755,cvsowner,cvsadmin) /home/cvsowner/cvsd-root/cvsroot

%changelog
* Wed Oct 27 1999 Progfou
- Rewrote cvsd.spec

* Sun May 9 1999 Chris Black
- Updated to 0.6, made %install install cvsd-pass itself.

* Tue May 4 1999 Chris Black
- Made initial rpm spec file and install script.

